# -*- coding: UTF-8 -*-
from setuphelpers import *
import requests
import json


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    arch = {"x64": "win64", "x86": "win", "all": "win"}

    # Downloading
    lang = control.locale
    # Translating locale
    if "en" in lang:
        lang = "en-US"
    if "es" in lang:
        lang = "es-ES"

    url_dl = requests.head(
        "https://download.mozilla.org/?product=thunderbird-latest&os=%s&lang=%s" % (arch[control.architecture], lang), proxies=proxies
    ).headers["Location"]
    latest_bin = url_dl.rsplit("/", 1)[1].replace("%20", "_")
    version = url_dl.split("/")[-4]

    version_from_api = (
        json.loads(wgets("https://product-details.mozilla.org/1.0/thunderbird_versions.json", proxies=proxies))
        .get("LATEST_THUNDERBIRD_VERSION", "0")
    )

    if Version(version_from_api) > version:
        url_dl = url_dl.replace(version, version_from_api)
        version = version_from_api
        latest_bin = url_dl.rsplit("/", 1)[1].replace("%20", "_")

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return result
